// -*- C++ -*-
/*!
 * @file  ShowComponent.cpp
 * @brief Show Component
 * $Date$
 *
 * $Id$
 */

#include <iostream>
#include "ShowComponent.h"
//#include "Camera.h"


//CvCapture* capture = 0;


// Module specification
// <rtc-template block="module_spec">
static const char* showcomponent_spec[] =
  {
    "implementation_id", "ShowComponent",
    "type_name",         "ShowComponent",
    "description",       "Show Component",
    "version",           "0.1",
    "vendor",            "Osaka Univ.",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "5",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.int_width","320",
    "conf.default.int_height","240",

    ""
  };
// </rtc-template>

ShowComponent::ShowComponent(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_ImageDataIn("ImageData", m_ImageData),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("ImageData", m_ImageDataIn);
  
  printf("initialize\n");

  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

	src = NULL;
	i = 0;

}

ShowComponent::~ShowComponent()
{
}


RTC::ReturnCode_t ShowComponent::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable

  bindParameter("int_width", m_int_width, "320");
  bindParameter("int_height", m_int_height, "240");

  
  //cvNamedWindow("Capture", CV_WINDOW_AUTOSIZE);


  // </rtc-template>
  return RTC::RTC_OK;
}




RTC::ReturnCode_t ShowComponent::onFinalize()
{
  cvDestroyWindow("Capture");
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t ShowComponent::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ShowComponent::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t ShowComponent::onActivated(RTC::UniqueId ec_id)
{

  cvNamedWindow("Capture", CV_WINDOW_AUTOSIZE);

  src = cvCreateImage( cvSize(m_int_width,m_int_height),IPL_DEPTH_8U, 3);//NULL;
  //IplImage* buf2 = NULL;
  //IplImage* buf3 = NULL;

  return RTC::RTC_OK;
}



RTC::ReturnCode_t ShowComponent::onDeactivated(RTC::UniqueId ec_id)
{

  //cvReleaseCapture(0);//NULL;
  cvDestroyWindow("Capture");

  return RTC::RTC_OK;
}



RTC::ReturnCode_t ShowComponent::onExecute(RTC::UniqueId ec_id)
{
  //m_ImageData.data.length(120*160);
  m_ImageDataIn.read();
  
  //cout<<m_ImageData.data.length()<<endl;
  //printf("test\n");


  if(m_ImageData.data.length()==m_int_width*m_int_height*3){
    memcpy(src->imageData,(void *)&(m_ImageData.data[0]),m_int_width*m_int_height*3);
  }
  cvShowImage("Capture", src);
  cvWaitKey(100);


  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t ShowComponent::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ShowComponent::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ShowComponent::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ShowComponent::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ShowComponent::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void ShowComponentInit(RTC::Manager* manager)
  {
    RTC::Properties profile(showcomponent_spec);
    manager->registerFactory(profile,
                             RTC::Create<ShowComponent>,
                             RTC::Delete<ShowComponent>);
  }
  
};


